class FfasterGenerator < Rails::Generators::Base
  source_root File.expand_path('../templates', __FILE__)
  argument :name, :type => :string, :default => "application"

  def generate_app
    recreate 'app/assets/stylesheets/application.', 'css', 'scss'
    recreate 'app/assets/javascripts/application.', 'js', 'coffee'

    recreate 'app/views/layouts/application.', 'html.rb', 'haml'

    recreate 'config/database.yml'
    recreate 'config/routes.rb'

    recreate 'Gemfile'
    recreate 'README.', 'rdoc', 'md'
    recreate '.rspec'

    config_specs
    recreate 'Guardfile'
  end

  private

  def recreate(path, old_extension = '', new_extension = '')
    remove_file path + old_extension
    template path + new_extension
  end

  def config_specs
    remove_dir 'tests'
    recreate 'spec/rails_helper.rb'
    recreate 'spec/spec_helper.rb'
  end
end
